#!/usr/bin/python -tt
import __main__
__main__.__requires__ = 'fedora_packagedb'

import sys
import os
sys.stdout = sys.stderr
sys.path.append(os.path.join('/usr/share', 'fedora-packagedb'))

import pkg_resources
pkg_resources.require("CherryPy<3.0")

os.environ['PYTHON_EGG_CACHE'] = '/var/www/.python-eggs'

import atexit
import cherrypy
import cherrypy._cpwsgi
import turbogears
import fedora.tg.util

turbogears.config.update({'global': {'mako.directories': [os.path.join(
    '/usr/share', 'fedora-packagedb/pkgdb/templates')]}})
turbogears.update_config(configfile=os.path.join('/etc', 'pkgdb.cfg'),
        modulename="pkgdb.config")
# This must always be off when used with mod_wsgi
turbogears.config.update({'global': {'autoreload.on': False}})

import pkgdb.lib.utils
pkgdb.lib.utils.init_globals()
turbogears.startup.call_on_startup.append(fedora.tg.util.enable_csrf)

import pkgdb.controllers
cherrypy.root = pkgdb.controllers.Root()

if cherrypy.server.state == 0:
    atexit.register(cherrypy.server.stop)
    cherrypy.server.start(init_only=True, server_class=None)

application = cherrypy._cpwsgi.wsgiApp
